jvx.vector

## Class PwIsoline

- java.lang.Object
- - jv.object.PsObject
  - - jvx.project.PjWorkshop
    - - jvx.vector.PwIsoline

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, PsUpdateIf, PjWorkshopIf

      public class PwIsoline
      extends PjWorkshop

  Study scalar fields on a surface which are given as vector fields of dimension 1. Compute level lines as polygon set or assign vertex colors based on the scalar.
  See Also:
    Serialized Form
  Author:
    Konrad Polthier, Klaus Hildebrandt
  Version:
    01.03.04, 1.00 created (kp)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `RANGE_FULL`
    `static int` | `RANGE_HIGHER`
    `static int` | `RANGE_LOWER`
    `static int` | `RANGE_MAJOR`

    - ### Fields inherited from class jv.object.PsObject

      `HAS_BOUNDARY_PANEL, HAS_CONFIG_PANEL, HAS_INFO_PANEL, HAS_LABEL_PANEL, HAS_MATERIAL_PANEL, HAS_TEXTURE_PANEL, HAS_VECTOR_PANEL, INSPECTOR_INFO, INSPECTOR_INFO_EXT, IS_DELETED, IS_FIXED, IS_FOCUSSED, IS_PICKED, IS_SELECTED, IS_USED, NUM_TAGS`

    - ### Fields inherited from interface jv.project.PjWorkshopIf

      `MODE_BUG, MODE_STANDARD, MODE_VALIDATE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PwIsoline()` Constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cancel()` Cancel operation of this workshop by resetting the assigned geometry, and finally close this workshop.
    `PdVector` | `getLevels()`
    `int` | `getRangeType()`
    `void` | `init()` Initialize and reset project, stops the running animation if any.
    `void` | `makeIsolines()` Compute isolines of selected scalar field of geometry.
    `static PgPolygonSet` | `makeIsolines(PgElementSet geom, PdVector levels, PgPolygonSet isolines, PdVector scalar)` Computes a set of isolines of a scalar field on a triangulated surface.
    `void` | `reset()` Reset workshop and geometry to original state.
    `void` | `setGeometry(PgGeometry geom)` Assign a geometry on which this workshop operates, and create a backup clone of the geometry.
    `void` | `setLevels(PdVector level)`
    `void` | `setRangeType(int type)`
    `boolean` | `update(java.lang.Object event)` Each time another geometry is loaded.

    - ### Methods inherited from class jvx.project.PjWorkshop

      `close, getDisplay, getDisplays, getGeometry, getMode, getSavedGeometry, getViewer, isModal, isStandalone, ok, removeGeometry, setDisplay, setDisplays, setModal, setMode, setStandalone, setViewer`

    - ### Methods inherited from class jv.object.PsObject

      `addInspector, addUpdateListener, assureInspector, clearTag, clone, clone, clone, copy, getFather, getInfoPanel, getInspector, getName, getNumObjects, getSymbol, hasInspector, hasTag, hasUpdateListener, instanceOf, instanceOf, newInspector, newInspector, removeInspector, removeInspector, removeUpdateListener, setName, setParent, setSymbol, setTag, toString, updatePanels`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jv.object.PsUpdateIf

      `getFather, getName, setParent`

- - ### Field Detail

    - #### RANGE_MAJOR

          public static final int RANGE_MAJOR

      See Also:
        Constant Field Values

    - #### RANGE_LOWER

          public static final int RANGE_LOWER

      See Also:
        Constant Field Values

    - #### RANGE_HIGHER

          public static final int RANGE_HIGHER

      See Also:
        Constant Field Values

    - #### RANGE_FULL

          public static final int RANGE_FULL

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PwIsoline

          public PwIsoline()

      Constructor.

  - ### Method Detail

    - #### init

          public void init()

      Description copied from class: `PjWorkshop`
      Initialize and reset project, stops the running animation if any. Does not reset any registered display nor geometry. They must be reset individually in each subclass.
      Overrides:
        `init` in class `PjWorkshop`

    - #### reset

          public void reset()

      Reset workshop and geometry to original state.
      Overrides:
        `reset` in class `PjWorkshop`

    - #### update

          public boolean update(java.lang.Object event)

      Each time another geometry is loaded.
      Specified by:
        `update` in interface `PsUpdateIf`
      Overrides:
        `update` in class `PjWorkshop`
      Parameters:
        `event` - sender of this update.
      Returns:
        true if update was correctly handled by superclass.
      See Also:
        `PsObject.setParent(PsUpdateIf)`, `PsObject.getFather()`, `PsObject.addUpdateListener(PsUpdateIf)`

    - #### setGeometry

          public void setGeometry(PgGeometry geom)

      Description copied from class: `PjWorkshop`
      Assign a geometry on which this workshop operates, and create a backup clone of the geometry. The backup geometry is restored if the workshop is canceled.

      Subclasses frequently overwrite this method but are advised to call this method.

      Specified by:
        `setGeometry` in interface `PjWorkshopIf`
      Overrides:
        `setGeometry` in class `PjWorkshop`
      Parameters:
        `geom` - the workshop modifies this geometry.

    - #### cancel

          public void cancel()

      Cancel operation of this workshop by resetting the assigned geometry, and finally close this workshop.

      If necessary, the duplicate of the original geometry is restored into the geometry.

      Overrides:
        `cancel` in class `PjWorkshop`

    - #### getLevels

          public PdVector getLevels()

    - #### setLevels

          public void setLevels(PdVector level)

    - #### getRangeType

          public int getRangeType()

    - #### setRangeType

          public void setRangeType(int type)

    - #### makeIsolines

          public void makeIsolines()

      Compute isolines of selected scalar field of geometry.
      Version:
        01.03.04, 1.00 created (kp)

    - #### makeIsolines

          public static PgPolygonSet makeIsolines(PgElementSet geom,
                                                  PdVector levels,
                                                  PgPolygonSet isolines,
                                                  PdVector scalar)

      Computes a set of isolines of a scalar field on a triangulated surface. The function is given as a PdVector. Each double of the vector is regarded as the function value of the vertex of the surface with the corresponding index. In the interior of elements the function is linearly interpolated. The isolines are returned as a list of polygons each consisting of only one edge. The isovalue of each polygon is given as a PdVector. To simplify the polygon set see `PuCleanMesh.identifyVertices(PgGeometry)` and `PwCleanMesh.joinPolygons`.
      Parameters:
        `geom` - Base surface must consist of triangles only.
        `levels` - List of values sorted by increasing value, determines the computed isolines.
        `isolines` - Isocurves which will be computed.
        `scalar` - Scalar values at each vertex of the base geometry.
      Since:
        JavaView 2.65.000
      Version:
        20.03.03, 1.10 created (ep) Body inherited from original non-static method makeIsolines. 00.07.02, 1.00 created (kh) Original body of method.

"

The software JavaView? is copyright protected. All Rights Reserved.
"